# Feature Introduction

- [Feature Introduction](#feature-introduction)
  - [Switch Account](#switch-account)
  - [Off-Stage Performance: Twilight Chord](#off-stage-performance-twilight-chord)
    - [Fast Mode](#fast-mode)
    - [Normal Mode](#normal-mode)
      - [Pinning Demonstration](#pinning-demonstration)
      - [Pinning Successful](#pinning-successful)

## Switch Account

This function only switches the last account currently logged in (accounts beyond the third one will be ignored).
After switching, you can continue adding tasks to run tasks with multiple accounts and configurations.

## Off-Stage Performance: Twilight Chord

（局外演绎：黄昏的音序）The most useful roguelike mode for farming credits.

### Fast Mode

> [!NOTE]
>
> 1. Before using the fast farming function, please fully level up `Engrave Growth - Song of Guidance（刻画生长-指引之歌）`.
> 2. Please set the difficulty level as high as possible to prevent insufficient scores leading to failure in farming tokens.
> 3. To adjust the difficulty, manually select the target difficulty level, go to the catalyst selection interface, and then exit.

### Normal Mode

> [!TIP]
>
> 1. Before use, you can pin (mark) four characters in your box to serve as the deployed characters.
> 2. It's recommended to include a healer in the team composition.
> 3. Please make sure that the last battle was in automatic combat before use. M9A cannot check whether it is in automatic combat.

> [!WARNING]
>
> 1. M9A does not handle the story, tutorials, etc., that appear only when playing the roguelike mode for the first time. You need to complete it manually once before using this function.

> [!NOTE]
> Due to the complexity of this function's implementation, strange issues may occur. If possible, please enable screen recording on your emulator. When encountering problems, try to preserve sufficient information (all content under the `debug` and `logs` directories) so that developers can quickly locate and resolve the issue. [Click here to submit an issue](https://github.com/MAA1999/M9A/issues/new/choose)

#### Pinning Demonstration

![Pinning Demonstration](https://github.com/user-attachments/assets/ff9d66d8-9540-447a-9eac-315caec00fe9)

#### Pinning Successful

![Pinning Successful](https://github.com/user-attachments/assets/d88fea79-df1b-4651-9d6d-386a40bf3b55)
