# 新手上路

- [新手上路](#新手上路)
  - [前置准备](#前置准备)
    - [1. 确认版本系统](#1-确认版本系统)
    - [2. 安装运行环境](#2-安装运行环境)
      - [Windows](#windows)
      - [其他系统](#其他系统)
        - [环境依赖](#环境依赖)
        - [依赖管理](#依赖管理)
    - [3. 下载正确的版本](#3-下载正确的版本)
      - [Windows](#windows-1)
      - [macOS](#macos)
      - [Linux](#linux)
      - [Android](#android)
    - [4. 正确解压](#4-正确解压)
    - [5. 确认模拟器支持](#5-确认模拟器支持)
    - [6. 正确设置模拟器分辨率](#6-正确设置模拟器分辨率)
    - [7. pip 设置（Windows）](#7-pip-设置windows)
  - [相关文档](#相关文档)

## 前置准备

### 1. 确认版本系统

M9A 在 Windows 下仅支持 10 和 11，旧版 Windows 请参阅[常见问题](https://maa.plus/docs/zh-cn/manual/faq.html#%E7%B3%BB%E7%BB%9F%E9%97%AE%E9%A2%98)中的系统问题部分。

> [!WARNING]
>
> 以下内容源自 MAA，与 M9A 有差异，故仅供参考
> [暂不支持 PlayCover](https://github.com/MaaXYZ/MaaFramework/issues/405)。

若您正在使用 Apple Silicon MacBook，请前往[此页面](https://maa.plus/docs/zh-cn/manual/device/macos.html#apple-silicon-%E8%8A%AF%E7%89%87)
M9A 同样支持搭载 [Intel 芯片](https://maa.plus/docs/zh-cn/manual/device/macos.html#intel-%E8%8A%AF%E7%89%87)的 MacBook，但更推荐使用 Mac 自带的多系统安装 Windows，并使用 Windows 版 M9A。

若您希望使用 Android 实体设备，请前往[此页面](https://maa.plus/docs/zh-cn/manual/device/android.html)。
由于此方法涉及 adb 调试且仍需与电脑连接，不推荐入门玩家使用此方法。

### 2. 安装运行环境

#### Windows

对于Windows需要在运行前安装运行库。

M9A 需要 VCRedist x64 (cli与gui都需要) 和 .NET 8 (仅使用gui时需要)。
点击 [vc_redist.x64](https://aka.ms/vs/17/release/vc_redist.x64.exe) 下载安装 VCRedist x64，点击 [dotnet-sdk-8.0.5-win-x64.exe](https://download.visualstudio.microsoft.com/download/pr/ba3a1364-27d8-472e-a33b-5ce0937728aa/6f9495e5a587406c85af6f93b1c89295/dotnet-sdk-8.0.404-win-x64.exe) 下载安装.NET 8。
也可以右键开始按钮打开终端，在终端内粘贴以下命令回车以进行安装。

```sh
winget install Microsoft.VCRedist.2017.x64 Microsoft.DotNet.DesktopRuntime.8
```

#### 其他系统

##### 环境依赖

Python: 版本 ≥ 3.10

##### 依赖管理

运行环境必须满足 `requirements.txt` 文件中所有必要的依赖包及其版本。

### 3. 下载正确的版本

M9A 下载（更新）地址：<https://github.com/MAA1999/M9A/releases>

国内用户也可通过 [Mirror酱](https://mirrorchyan.com/zh/download?rid=M9A) 高速下载。

#### Windows

- 对于**绝大部分**用户，请下载 `M9A-win-x86_64-vXXX.zip`
- ~~若确定自己的电脑是 arm 架构，请下载 `M9A-win-aarch64-vXXX.zip`~~
- arm 架构目前已不支持

> [!WARNING]
> 请注意！Windows 的电脑几乎全都是 x86\_64 的，可能占 99.999%，除非你非常确定自己是 arm，否则别下这个！

- 解压后运行 `MaaPiCli.exe`（命令行）或 `MFAWPF.exe`（图形化界面）即可

#### macOS

- 查看处理器类型（重要：一定要选择正确版本才能正确运行）：

  1. 点击屏幕左上角的苹果标志。
  2. 选择“关于本机”。
  3. 在弹出的窗口中，你可以看到处理器的信息。

- 若使用 Intel X86 处理器，请下载 `M9A-macos-x86_64-vXXX.zip`
- 若使用 Apple Silicon 系列如： M1, M2 等 ARM 架构处理器，请下载 `M9A-macos-aarch64-vXXX.zip`

- 使用方式：

    1. 打开终端，解压分发的压缩包，推荐解压到 `usr/local/bin` 中，不建议存放于 `/opt` 中避免权限问题。

        ```shell
        sudo unzip -o <下载的M9A压缩包路径> -d usr/local/bin/M9A
        ```

    2. 继续在终端中赋予UNIX可执行文件的执行权限：

        ```shell
        cd usr/local/bin/M9A
        # 如果手动在解压好的软件根目录打开终端，可以免除执行上面这一行
        sudo chmod 777 MaaPiCli
        sudo ./MaaPiCli
        ```

    3. 若想使用图形操作页面请按第二步操作，执行 `MFAAvalonia` 程序。

#### Linux

同macOS，下载对应版本的压缩包，添加权限后运行 `MaaPiCli` 即可。

#### Android

~~对于一般用户我们并不推荐该版本，故已在发行版删除~~
如您非常了解手机操作，可参考[使用方法](https://github.com/MaaXYZ/MaaFramework/issues/475)，以及[开发文档](../develop/开发前须知.md)自行安装。

### 4. 正确解压

确认解压完整，并确保将 M9A 解压到一个独立的文件夹中。除关闭内建管理员批准的Administrator账号外，请勿将 MAA 解压到如 `C:\`、`C:\Program Files\` 等需要 UAC 权限的路径。

> [!CAUTION]
> 不要在压缩软件直接打开程序！

### 5. 确认模拟器支持

查阅[模拟器和设备支持](https://maa.plus/docs/zh-cn/manual/device/)，确认正在使用的模拟器支持情况。

### 6. 正确设置模拟器分辨率

模拟器分辨率应为 `16:9` 比例，推荐（以及最低）分辨率为 `1280x720`，不符合要求造成的运行报错将不会被解决。

### 7. pip 设置（Windows）

对于 Windows，为了大多数用户使用方便，我们专门附带了 Python 环境，但同时考虑到尽可能减小安装包大小，选择让程序在本地首次运行或资源版本更新时使用 pip 安装所有依赖，相关配置文件存储在 `config/pip_config.json` 中（不存在则自动创建）。内容如下：

```jsonc
{
    "enable_pip_update": true,  # 是否更新 pip 本体，默认 true，推荐开启
    "enable_pip_install": true,  # 是否启用 pip 安装，默认 true，推荐开启
    "last_version": "v3.2.0",  # 完成 pip 安装时读取 interface.json 的 version ，启动时和 version 对比，不同则尝试安装
    "mirror": "https://mirrors.ustc.edu.cn/pypi/simple" # 镜像源。pip install -i 后参数，可根据个人需求填写。注意非大陆地区用户请修改值为 ""
}
```

## 相关文档

- [连接设置](./连接设置.md#连接设置)——介绍了adb连接以及模拟器设置
- [MaaPiCli操作说明](./MaaPiCli.md)——介绍了 MaaPiCli 使用方法~~翻译文档~~
- [功能介绍](./功能介绍.md)——介绍了部分功能的注意事项
- [常见问题](./常见问题.md)——介绍了常见问题及解决策略
- [Mirror酱使用说明](./Mirror酱.md)——介绍了Mirror酱使用方法
